"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
//Decode
//Input 16 digit str
//Out unlock str
var GetReverse_1 = require("./GetReverse");
var CharSep_1 = require("./CharSep");
var FullBin_1 = require("./FullBin");
var erc = 'C412240C3133D72';
function decode(input) {
    return __awaiter(this, void 0, void 0, function () {
        var fConv;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (typeof input !== 'string' || input.length !== 16) {
                        throw Error('Invalid input');
                    }
                    fConv = new Int32Array(1);
                    return [4 /*yield*/, CharSep_1.CharSep(input, 0, 8)
                            .then(function (data1) {
                            fConv[0] = parseInt(data1, 16);
                            return CharSep_1.CharSep(input, 8, 8);
                        })
                            .then(function (data2) {
                            var sConv = new Int32Array(1);
                            sConv[0] = parseInt(data2, 16);
                            return sConv[0];
                        })
                            .then(function (bin) {
                            var unbit = FullBin_1.FullBin((bin >>> 0).toString(2), 32);
                            return unbit;
                        })
                            .then(function (unbit) {
                            return GetReverse_1.GetReverse(unbit);
                        })
                            .then(function (fin) {
                            var test = new Int32Array(1);
                            test[0] = parseInt(fin, 2);
                            var secondPartRev = test[0];
                            return secondPartRev;
                        })
                            .then(function (secondPartRev) {
                            var xor = new Int32Array(1);
                            xor[0] = fConv[0] ^ secondPartRev;
                            return xor[0];
                        })
                            .then(function (xor) {
                            var ret = new Int32Array(1);
                            ret[0] = xor - 0xE010A11;
                            return ret[0];
                        })
                            .then(function (ret) {
                            var hex = (ret >>> 0).toString(16);
                            var final = FullBin_1.FullBin(hex, 8);
                            return final;
                        })
                            .catch(function (err) {
                            throw err;
                        })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.decode = decode;
//0011 0001 0011 0011 1101 0001 0111 0010
//01001110100010111100110010001100
decode(erc).then(function (data) {
    console.log(data);
});
// const a = "12345";
// var a = 3, b = 4;
// /*
// 0000 0011 << 4
// 0011 0000 = 16+32 = 48
// */
// var c = a << b;
// let x = new Int32Array(1);
// x[0] = 56;
// // FullBin(x[0].toString(2), 8)
// //     .then((data) => {
// //         console.log(parseInt(data.split('').reverse().join(''), 2));
// //     })
// // console.log(parseInt(x[0].toString(2).split('').reverse().join(''), 2));
// /*
// 56/2 = 28 0
// 28/2 = 14 0
// 14/2 = 7 0 
// 7/2 = 3 1
// 3/2 = 1 1
// 2/1 = 0 1
// 0011 1000
// 0001 1100
// */
// FullBin(x[0].toString(2), 8)
//     .then((data) => {
//         console.log(data)
//         console.log(GetReverse(data));
//     })
